/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (6.0.0).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package uk.co.beacon.customerservice.resources.interfaces;

import uk.co.beacon.customerservice.EntityModelTransportCall;
import uk.co.beacon.customerservice.PagedModelEntityModelTransportCall;
import uk.co.beacon.customerservice.TransportCallRequestBody;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import javax.annotation.Generated;

@Generated(value = "org.openapitools.codegen.languages.SpringCodegen")
@Validated
@Tag(name = "TransportCallEntityController", description = "the TransportCallEntityController API")
public interface TransportCallEntityControllerApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    /**
     * DELETE /transportCalls/{id}
     * delete-transportcall
     *
     * @param id  (required)
     * @return No Content (status code 204)
     *         or Not Found (status code 404)
     */
    @Operation(
        operationId = "deleteItemResourceTransportcallDelete",
        tags = { "transport-call-entity-controller" },
        responses = {
            @ApiResponse(responseCode = "204", description = "No Content"),
            @ApiResponse(responseCode = "404", description = "Not Found")
        }
    )
    @RequestMapping(
        method = RequestMethod.DELETE,
        value = "/transportCalls/{id}"
    )
    default ResponseEntity<Void> deleteItemResourceTransportcallDelete(
        @Parameter(name = "id", description = "", required = true) @PathVariable("id") String id
    ) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /transportCalls
     * get-transportcall
     *
     * @param page Zero-based page index (0..N) (optional, default to 0)
     * @param size The size of the page to be returned (optional, default to 20)
     * @param sort Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported. (optional)
     * @return OK (status code 200)
     */
    @Operation(
        operationId = "getCollectionResourceTransportcallGet1",
        tags = { "transport-call-entity-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = PagedModelEntityModelTransportCall.class)),
                @Content(mediaType = "application/x-spring-data-compact+json", schema = @Schema(implementation = PagedModelEntityModelTransportCall.class)),
                @Content(mediaType = "text/uri-list", schema = @Schema(implementation = PagedModelEntityModelTransportCall.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/transportCalls",
        produces = { "application/hal+json", "application/x-spring-data-compact+json", "text/uri-list" }
    )
    default ResponseEntity<PagedModelEntityModelTransportCall> getCollectionResourceTransportcallGet1(
        @Min(0) @Parameter(name = "page", description = "Zero-based page index (0..N)") @Valid @RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
        @Min(1) @Parameter(name = "size", description = "The size of the page to be returned") @Valid @RequestParam(value = "size", required = false, defaultValue = "20") Integer size,
        @Parameter(name = "sort", description = "Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.") @Valid @RequestParam(value = "sort", required = false) List<String> sort
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /transportCalls/{id}
     * get-transportcall
     *
     * @param id  (required)
     * @return OK (status code 200)
     *         or Not Found (status code 404)
     */
    @Operation(
        operationId = "getItemResourceTransportcallGet",
        tags = { "transport-call-entity-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = EntityModelTransportCall.class))
            }),
            @ApiResponse(responseCode = "404", description = "Not Found")
        }
    )
    @RequestMapping(
        method = RequestMethod.GET,
        value = "/transportCalls/{id}",
        produces = { "application/hal+json" }
    )
    default ResponseEntity<EntityModelTransportCall> getItemResourceTransportcallGet(
        @Parameter(name = "id", description = "", required = true) @PathVariable("id") String id
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * PATCH /transportCalls/{id}
     * patch-transportcall
     *
     * @param id  (required)
     * @param transportCallRequestBody  (required)
     * @return OK (status code 200)
     *         or No Content (status code 204)
     */
    @Operation(
        operationId = "patchItemResourceTransportcallPatch",
        tags = { "transport-call-entity-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = EntityModelTransportCall.class))
            }),
            @ApiResponse(responseCode = "204", description = "No Content")
        }
    )
    @RequestMapping(
        method = RequestMethod.PATCH,
        value = "/transportCalls/{id}",
        produces = { "application/hal+json" },
        consumes = { "application/json" }
    )
    default ResponseEntity<EntityModelTransportCall> patchItemResourceTransportcallPatch(
        @Parameter(name = "id", description = "", required = true) @PathVariable("id") String id,
        @Parameter(name = "TransportCallRequestBody", description = "", required = true) @Valid @RequestBody TransportCallRequestBody transportCallRequestBody
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * POST /transportCalls
     * create-transportcall
     *
     * @param transportCallRequestBody  (required)
     * @return Created (status code 201)
     */
    @Operation(
        operationId = "postCollectionResourceTransportcallPost",
        tags = { "transport-call-entity-controller" },
        responses = {
            @ApiResponse(responseCode = "201", description = "Created", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = EntityModelTransportCall.class))
            })
        }
    )
    @RequestMapping(
        method = RequestMethod.POST,
        value = "/transportCalls",
        produces = { "application/hal+json" },
        consumes = { "application/json" }
    )
    default ResponseEntity<EntityModelTransportCall> postCollectionResourceTransportcallPost(
        @Parameter(name = "TransportCallRequestBody", description = "", required = true) @Valid @RequestBody TransportCallRequestBody transportCallRequestBody
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * PUT /transportCalls/{id}
     * update-transportcall
     *
     * @param id  (required)
     * @param transportCallRequestBody  (required)
     * @return OK (status code 200)
     *         or Created (status code 201)
     *         or No Content (status code 204)
     */
    @Operation(
        operationId = "putItemResourceTransportcallPut",
        tags = { "transport-call-entity-controller" },
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = EntityModelTransportCall.class))
            }),
            @ApiResponse(responseCode = "201", description = "Created", content = {
                @Content(mediaType = "application/hal+json", schema = @Schema(implementation = EntityModelTransportCall.class))
            }),
            @ApiResponse(responseCode = "204", description = "No Content")
        }
    )
    @RequestMapping(
        method = RequestMethod.PUT,
        value = "/transportCalls/{id}",
        produces = { "application/hal+json" },
        consumes = { "application/json" }
    )
    default ResponseEntity<EntityModelTransportCall> putItemResourceTransportcallPut(
        @Parameter(name = "id", description = "", required = true) @PathVariable("id") String id,
        @Parameter(name = "TransportCallRequestBody", description = "", required = true) @Valid @RequestBody TransportCallRequestBody transportCallRequestBody
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf(""))) {
                    String exampleString = "";
                    ApiUtil.setExampleResponse(request, "", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
